#!/usr/bin/python
#
# Tiny Python Forum 0.2
#
# "...dedicated to all my friends"
#
# by Gorny (gorny@hobbiton.org) 
# http://gorny.cjb.net
#
# Copyright (C) 2001 (see License.txt for details)

import cgi
import Cookie
import md5
import os
import string
import sys

DATA = '/var/www/cgi-bin/forum/data/'
COLOR_A = '808080'
COLOR_B = '999999'
CGINAME = 'forum.py'
SENDMAIL = '/usr/sbin/sendmail'
WEBSITE = 'http://ebh.hobbiton.org/'

def switchcolor(color):
    colors = [COLOR_A, COLOR_B]
    if color == colors[0]:
        color = colors[1]
    else:
        color = colors[0]
    return color

def getregisters():
    filedata = open(DATA + 'register.txt', 'r').readlines()
    registers = []
    for a in range(0, len(filedata)):
        registers.append(string.split(filedata[a]))
    return registers

def getusers():
    filedata = open(DATA + 'users.txt', 'r').readlines()
    users = []    
    for a in range(0, len(filedata)):
        users.append(string.split(filedata[a]))
    return users

def getstatus(username):
    users = getusers()
    mode = 'Unknown'
    for a in range(0, len(users)):
        if username == users[a][0]:
            mode = MODES[int(users[a][3])]
    return mode

def checklogin(loginname, password):
    users = getusers()
    for a in range(0, len(users)):
        if (users[a][0] == loginname and users[a][2] == password):
            return 'oke'
    return ''    

def setcookie(login, password):
    cookie = Cookie.SimpleCookie()
    cookie['login'] = login
    cookie['password'] = md5.new(password).hexdigest()
    return cookie

def getcookie(environ=os.environ):
    try:
        cookie = string.split(environ['HTTP_COOKIE'], ';')
        cookie[0] = string.replace(cookie[0], 'password=', '')
        cookie[1] = string.replace(cookie[1], ' login=', '')
    except:
        return '', ''
    return cookie[0], cookie[1]

def filter(msg):
    msg = cgi.escape(msg, 1)
    for a in range(0, len(UBBC)):
        lnumber = string.count(string.lower(msg), UBBC[a][0])
        rnumber = string.count(string.lower(msg), UBBC[a][2])
        if lnumber != 0 and rnumber != 0 and rnumber == lnumber:
            msg = string.replace(msg, UBBC[a][0], UBBC[a][1])
            msg = string.replace(msg, UBBC[a][2], UBBC[a][3])
        flnumber = string.find(string.lower(msg), '[link]')
        frnumber = string.find(string.lower(msg), '[/link]')
        lnumber = string.count(string.lower(msg), '[link]')
        rnumber = string.count(string.lower(msg), '[/link]')
        if lnumber != -1 and rnumber != -1:
            while lnumber > 0 and rnumber > 0:
                link = ''
                lnumber = lnumber - 1
                rnumber = rnumber - 1
                for a in range(flnumber+6, frnumber):
                    link = link + msg[a]
                msg = string.replace(msg, '[link]', '<a href="' + link + '">')
                print link
                msg = string.replace(msg, link + '[/link]', link + '</a>')
    return msg

def printheaders():
    print '''Content-Type: text/html\n
          <html><head><title>Forum</title></head>
          <body link="#000000" vlink="#000000" alink="#000000">
          <p align="center"><a href="''' + CGINAME + '?action=index">' + \
          'Tiny Python Forum ' + VERSION + '</a></p><p align="right"><table border="0" width="100%"><br><br>'

def printerror(errormsg='Unidentified error occured!'):
    printheaders()
    print '</table><p align="center"><b><h1>' + errormsg + '</h1></b></p>'

def timenow():
    import time
    _time = time.strftime('%a %d-%m-%Y %H:%M:%S', time.localtime(time.time()))
    del time
    return _time

class Actions:
    
    def __init__(self, vars):
        self.vars = vars
        self.msg = self.notdecpassword = self.subject = self.regcode = ''
        self.rep = self.regpass = self.regcheckpass = self.reglogin = self.email = ''
        self.no = 0
        self.password, self.loginname = getcookie()
        if vars.has_key('no'):
            self.no = vars['no'].value
            try:
                self.no = int(self.no)
            except:
                self.no = -1
        if vars.has_key('rep'):
            self.rep = vars['rep'].value
            try:
                self.rep = int(self.rep)
            except:
                self.rep = ''
        if vars.has_key('msg'):
            self.msg = vars['msg'].value
        if vars.has_key('subject'):
            self.subject = vars['subject'].value
        if vars.has_key('login'):
            self.loginname = vars['login'].value
        if vars.has_key('pass'):
            self.notdecpassword = vars['pass'].value
            self.password = md5.new(self.notdecpassword).hexdigest()
        if vars.has_key('regpass'):
            self.regpass = vars['regpass'].value
        if vars.has_key('regcheckpass'):
            self.regcheckpass = vars['regcheckpass'].value
        if vars.has_key('regcode'):
            self.regcode = vars['regcode'].value
        if vars.has_key('email'):
            self.email = vars['email'].value
        if vars.has_key('reglogin'):
            self.reglogin = vars['reglogin'].value

    def action(self, actionname):
        getattr(Actions, actionname)(self)

    def index(self):
        printheaders()
        print '<p align="right"><font size="2"><a href="' + CGINAME + '?action=post">New</a> | ' + \
              '<a href="' + CGINAME +'?action=register">Register</a> | ' + \
            '<a href="' + CGINAME + '?action=help">Help</a>' + \
        '''<tr>
          <td width="55%" bgcolor="#000000"><b><font color="#FFFFFF">Topic</font></b></td>
          <td width="15%" bgcolor="#000000"><b><font color="#FFFFFF">By</font></b></td>
          <td width="25%" bgcolor="#000000"><b><font color="#FFFFFF">Date</font></b></td>
          <td width="50%" bgcolor="#000000"><b><font color="#FFFFFF">Replies</font></b></td>
        </tr>'''
        color = switchcolor(COLOR_B)
        filedata = open(DATA + 'data.txt', 'r').readlines()
        
	for a in range(len(filedata), 0, -1):
            thread = open(DATA + string.split(filedata[a-1])[1], 'r')
            color = switchcolor(color)
            print '<tr><td bgcolor="' + color + '" width="55%"><a href="' + CGINAME + '?action=view&no=' + `a` + \
                  '">' + thread.readline() +  \
                  '</a></td><td bgcolor="' + color + '"width="15%">' + thread.readline() + \
                  '</td><td bgcolor="' + color + '"width="25%">' + \
                  thread.readline() + '</td><td bgcolor="' + color + '"width="5%">' + \
                  `int(string.split(filedata[a-1])[0])-1` + '</td>'
            thread.close()

        print '</table>'
        if checklogin(self.loginname, self.password) != 'oke':
            print '''
                <p align="right">
                <form method="POST" action="''' + CGINAME + '''?action=login">
                Login:<input type="text" name="login" size="10" value="''' + \
                self.loginname + '''">Password:<input type="password" name="pass" size="10" value="''' + \
                self.notdecpassword + '''"><input type="hidden" name="_action" value="index">
                 <input type="submit" value="login" name="action">
                </form></p>'''

    def login(self):    
        check = checklogin(self.loginname, self.password)
        if check == 'oke':
            print setcookie(self.loginname, self.notdecpassword)
            self.index()
        else:
            printheaders()
            self.loginname = self.password = ''
            printerror('Wrong loginname and/or password!')

    def delmsg(self):
        if self.no <= 0:
            self.index()
            return

        datafile = open(DATA + 'data.txt', 'r').readlines()
        if cmp(len(datafile), self.no) < 0:
            self.index()
            return
        
        if self.rep > 0 and self.rep != '':
            file = open(DATA + string.split(open(DATA + 'data.txt', 'r').readlines()[self.no-1])[1])
            filedata = file.readlines()
    
            _rep = 1
            for a in range(0, len(filedata)):
                if string.count(filedata[a], '<>') != 0:
                    _rep = _rep + 1
                    if self.rep + 1 == _rep:
                        break
            _rep = a
            filedata.pop(_rep)
            if getstatus(self.loginname) == MODES[0] or getstatus(self.loginname) == MODES[1] or filedata[_rep] == self.loginname + '\n':
                while 1:
                    if string.count(filedata[_rep], '<>') != 0:
                        break
                    if _rep <= len(filedata):
                        filedata.pop(_rep)
                    else:
                        break
                    print filedata
                file.close()
                file = open(DATA + string.split(open(DATA + 'data.txt', 'r').readlines()[self.no-1])[1], 'w')
                file.seek(0,2)
                for a in range(0, len(filedata)):
                    file.write(filedata[a])
                file.close()
                data = `int(string.split(datafile[self.no-1])[0])-1` + ' ' + string.split(datafile[self.no-1])[1]
                datafile.pop(self.no-1)
                datafile.insert(self.no-1, data + '\n')
                file = open(DATA + 'data.txt', 'w')
                for a in range(0, len(datafile)):
                    file.write(datafile[a])
                file.close()
                self.view()
                
            else:
               printerror('You don`t have enough permissions to delete this message!')
                
        elif self.rep == '' or self.rep == 0:
            file = open(DATA + string.split(open(DATA + 'data.txt', 'r').readlines()[self.no-1])[1])
            filedata = file.readlines()
            file.close()
            if getstatus(self.loginname) == MODES[0] or self.loginname + '\n' == filedata[1]:
                filedata = open(DATA + 'data.txt', 'r').readlines()
                delfile = string.split(filedata[self.no-1])[1]
                filedata.pop(self.no-1)
                file = open(DATA + 'data.txt', 'w')
                for a in range(0, len(filedata)):
                    file.write(filedata[a])
                file.close()
                self.index()
                os.remove(DATA + delfile)
            else:
                printerror('You don`t have enough permissions to delete a whole thread!')
        datafile.close()

    def register(self):
        data = []
        data.append(self.regpass)
        data.append(self.regcheckpass)
        data.append(self.email)
        data.append(self.reglogin)
        if self.regpass != '' and self.regcheckpass != '' and self.email != '' and self.reglogin != '':
            users = getusers()
            for a in range(0, len(users)):
                if users[a][0] == self.reglogin:
                    printerror('That loginname already exists!')
                    return
                if users[a][1] == self.email:
                    printerror('Someone with that email-adres already registered!')
                    return
                if self.regpass != self.regcheckpass:
                    printerror('Your passwords don`t match!')
                    return
            registers = getregisters()
            for a in range(0, len(registers)):
                if registers[a][1] == self.email:
                    printerror('Someone with that email-adres already registered!')
                    return
                if registers[a][0] == self.reglogin:
                    printerror('That loginname already exists!')
                    return
            for a in range(0, len(data)):
                if string.find(data[a], ' ') != -1:
                    printerror('Your data contains whitespace!')
                    return
            code =  md5.new(self.reglogin).hexdigest()
            regcode = ''
            for a in range(0, 5):
                regcode = regcode + code[a]
            file = open(DATA + 'register.txt', 'r+')
            file.seek(0,2)
            data = self.reglogin + ' ' + self.email + ' ' + md5.new(self.regpass).hexdigest() + ' ' + regcode + '\n'
            file.write(data)
            file.close()
            file = open(DATA + 'tmp', 'w')
            file.write('Subject: Confirmation-code\nHello,\n\nThis is an automated response to your' + \
                       '\nsubscription. Just go to ' + WEBSITE + CGINAME + '?action=register' + \
                       '\nand confirm your subscription....with this code: ' + regcode + \
                       '\n\nYours sincerly,\nthe webmaster\n.\n')
            file.close()
            os.system(SENDMAIL + ' ' + self.email + ' < '  + DATA + 'tmp')
            printerror('Wait for the email with your confirmation-code to confirm your subscription')
            
        else:
            printheaders()
            print '</table><form method="POST" action="' + CGINAME + '?action=register">' + \
  '''<p>All fields are required. Please submit a valid email-adres, because you'll
  send you an<br>
  email with instructions, to confirm your subscription. No whitespace in either your loginname,
  password and/or email is allowed.</p>
  <table border="0">
    <tr>
      <td>Loginname:</td>
      <td><input type="text" name="reglogin" size="20"></td>
    </tr>
    <tr>
      <td>Password:</td>
      <td><input type="text" name="regpass" size="20"></td>
    </tr>
    <tr>
      <td>Password again:</td>
      <td><input type="text" name="regcheckpass" size="20"></td>
    </tr>
    <tr>
      <td>Email:</td>
      <td><input type="text" name="email" size="20"></td>
      <input type="hidden" name="action" value="register">
    </tr>
  </table><p><input type="submit" value="Register" name="button"></p>
  </form><form method="POST" action="''' + CGINAME + '?action=confirm">' + \
  '''
  <hr>
  <p>If you've received your confirmation-code, type it here to confirm your<br>
  subscription.</p>
  <table border="0">
    <tr>
      <td>Confirmation-code</td>
      <td><input type="text" name="regcode" size="20"></td>
      <input type="hidden" name="action" value="confirm">
    </tr>
  </table>
  <p><input type="submit" value="Confirm" name="button"><br>
  </p>
</form>'''

    def confirm(self):
        if self.regcode != '':
            registers = getregisters()
            for a in range(0, len(registers)):
                if registers[a][3] == self.regcode:
                    file = open(DATA + 'users.txt', 'r+')
                    file.seek(0,2)
                    for b in range(0,3):
                        file.write(registers[a][b] + ' ')
                    file.write('2\n')
                    file.close()
                    registers.pop(a)
                    file = open(DATA + 'register.txt', 'w')
                    for a in range(0, len(registers)):
                        file.write(registers[a][0] + ' ' + registers[a][1] + ' ' +\
                                   registers[a][2] + ' ' + registers[a][3] + '\n')
                    file.close()
                    printerror('Your registration is completed!')
                    return
            printerror('Your registration-code is not correct!')

    def reply(self):
        check = checklogin(self.loginname, self.password)
        if check != 'oke':
            printheaders()
            printerror('You are not logged in!')
            return

        if self.no <= 0:
            self.index()
            return
        
        datafile = open(DATA + 'data.txt', 'r+').readlines()
        if cmp(len(datafile), self.no) < 0:
            self.index()
            return

        if self.msg == '':
            self.view()
            print '</table><table><form method="POST" action="' + CGINAME + '?action=reply">' + \
                  '''<tr>
                <td width="30%" valign="top" align="right" bgcolor="808080">Message:</td>
                <td width="70%" align="left" bgcolor="808080"><textarea rows="12" cols="50" name="msg"></textarea>
                <input type="hidden" value="reply" name="action"><input type="hidden" value="''' + `self.no` + '"'
            print ' name="no"><p><input type="submit" value="Submit" name="button"></p></td></tr></table>'
            
        else:
            file = open(DATA + string.split(datafile[self.no-1])[1], 'r+')
            file.seek(0, 2)
            file.write(self.loginname + '\n')
            file.write(timenow() + '\n')
            file.write(filter(self.msg) + '\n<>\n')
            file.close()
            rep = int(string.split(datafile[self.no-1])[0])
            rep = rep + 1
            datafile[self.no-1] = `rep` + ' ' + string.split(datafile[self.no-1])[1] + '\n'
            file = open(DATA + 'data.txt', 'w')
            for a in range(0, len(datafile)):
                file.write(datafile[a])
            file.close()
            self.view()

    def post(self):
        check = checklogin(self.loginname, self.password)
        if check != 'oke':
            printheaders()
            printerror('You are not logged in!')
            return

        if self.msg == '' or self.subject == '':
            printheaders()
            print '<form method="POST" action="' + CGINAME + '?action=post">' +\
            '''<tr>
            <td width="30%" align="right" bgcolor="808080">Subject:</td>
            <td width="70%" align="left" bgcolor="808080"><input type="text" size="40" name="subject"></td>
              </tr>
              <tr>
            <td width="30%" valign="top" align="right" bgcolor="808080">Message:</td>
            <td width="70%" align="left" bgcolor="808080"><textarea rows="12" cols="50" name="msg"></textarea>
            <input type="hidden" value="post" name="action">
              <p><input type="submit" value="Submit" name="button"></p>
            </td>
              </tr></table>'''
        elif self.msg != None and self.subject != None:
            file = open(DATA + 'data.txt', 'r+')
            filedata = file.readlines()
            self.no = len(filedata) + 1
            if len(filedata) == 0:
                no = 1
            else:
                filedata = string.split(filedata[len(filedata)-1])
                no = int(string.split(filedata[1], '.')[0]) 
                no = no + 1
            while 1:
                if os.path.isfile(DATA + `no` + '.txt'):
                    no = no + 1
                else:
                    break
            file.write('1 ' + `no` + '.txt\n')
            file.close()
            file = open(DATA + `no` + '.txt', 'w')
            file.write(filter(self.subject) + '\n')
            file.write(self.loginname + '\n')
            file.write(timenow() + '\n')
            file.write(filter(self.msg) + '\n<>\n')
            file.close()
            self.view()              

    def help(self):
        printheaders()
        file = open(DATA + 'HELP', 'r')
        filedata = file.readlines()
        for a in range(0, len(filedata)):
            print filedata[a]
        file.close()

    def view(self):
        if self.no <= 0:
            self.index()
            return

        datafile = open(DATA + 'data.txt', 'r').readlines()
        if cmp(len(datafile), self.no) < 0:
            self.index()
            return
        
        printheaders()
        users = getusers()
                        
        print '<p align="right"><font size="2">' + \
              '<a href="' + CGINAME + '?action=reply&no=' + `self.no` + '">Reply</a>' + \
              ' | <a href="' + CGINAME + '?action=delmsg&no=' + `self.no` + '">Delete</a> | ' + \
              '<a href="' + CGINAME + '?action=post">New</a> | ' + \
              '<a href="' + CGINAME +'?action=register">Register</a> |' + \
              '<a href="' + CGINAME + '?action=help">Help</a></font></p>'
        print '''<table border="1" width="100%" cellspacing="0">
          <tr>
        <td width="25%" valign="top" bgcolor="#000000"><b><font color="#FFFFFF">Poster</font></b></td>
        <td width="75%" valign="top" bgcolor="#000000"><b><font color="#FFFFFF">Message</font></b></td>
          </tr>'''
        
        file = open(DATA + string.split(open(DATA + 'data.txt', 'r').readlines()[self.no-1])[1])
        filedata = file.readlines()
        
        color = switchcolor(COLOR_B)
        
        _postings = postings = int(string.split(open(DATA + 'data.txt', 'r').readlines()[self.no-1])[0])
        a = 0

        while postings != 0:      
            print '<tr><td width="25%" valign="top" bgcolor=' + color + '>' + filedata[a+1] + '<br>'
            print getstatus(string.split(filedata[a+1])[0]) + '<br>' + filedata[a+2] + '</td>'
            print '<td width="75%" valign="top" bgcolor=' + color + '>'
            if a == 0:
                print '<b>' + filedata[0] + '</b><hr>'
            elif string.find(filedata[a], '<>') == -1:
                print filedata[a]
            for b in range(a+3, len(filedata)):
                if string.find(filedata[b], '<>') != -1:
                    rep = `_postings-postings`
                    #print '<font size="2"><a href="' + CGINAME + '?action=reply&no=' + \
                    #`self.no` + '&rep=' + rep + '">Reply</a> |
                    print '<div align="right"><font size="2"><a href="' + CGINAME + \
                    '?action=delmsg&no=' + `self.no` + '&rep=' + rep + '">Delete</a></font></div>'
                    #print '<br></td></tr>'
                    a = b
                    break
                else:
                    print filedata[b] + '<br>'
            
            postings = postings - 1
            color = switchcolor(color)
        print '</td></tr></table>'

VERSION = '0.2'
MODES = ['BOFH',
         'Moderator',
         'User']

UBBC = [('[img]', '<img border="0" src="', '[/img]', '">'),
        ('[u]', '<u>', '[/u]', '</u>'),
        ('[i]', '<i>', '[/i]', '</i>'),
        ('[b]', '<b>', '[/b]', '</b>')]

# real execution starts here...
vars = cgi.FieldStorage()
act = Actions(vars)

if vars.has_key('action'):
    act.action(vars['action'].value)
else:
    act.index()

print '<p align="center"><br><a href="http://www.python.org"><img border="0" src="../../images/python.gif"></a></p></body></html>'
